#ifndef __HENONLIKE_ALT__
#define __HENONLIKE_ALT__

#include "typedefs.h"

class HenonLike {
 private:
  static const interval B;
  static const interval C;
  static const interval E;
  static const interval unCertain;
  static const interval renormalisationScaling;
  static TCoefTwo sigma;
  static IVector latestArg;
  static interval thisY;
  static void loadCoef();
  interval evalPhi(const TCoefOne &T, interval y) const;
  interval evalDPhiDY(const TCoefOne &T,interval y) const;
  interval evalSigma(interval x, interval y) const;
  interval evalS(interval x, interval y) const;
  interval evalDSigmaDX(interval x, interval y) const;
  interval evalDSigmaDY(interval x, interval y) const;
  interval evalZeroFunc(interval x, interval y, interval u) const;
  interval evalY(interval x, interval u) const;
  IVector rescale(IVector v, int k) const;
  IVector evalF(const IVector &xu) const;
  IVector evalGradS(interval x, interval y) const;
  IMatrix evalDF(interval x, interval y) const;
  
 public:  
  HenonLike();
  IVector operator()(const IVector &xu) const;
  IMatrix operator[](const IVector &xu) const;
  IVector inv(const IVector &xu) const;
};

IVector coord(const IVector &in, bool inverse);
IMatrix Dcoord(const IVector &in, bool inverse);
#endif
