#include "HenonLike.h"
#include <iomanip>
#include <fstream>


void initSets(HenonLike &H, HSet *hSet) {
  IVector centres[16];
 
  IVector w[8], wt[8];
  w[0][0]=0.788578889012330;
  w[0][1]= 0.614933602760558;
  w[1][0]= 0.982114476696540;
  w[1][1]= -0.188284770130463;
  w[2][0]= 0.997;//0.995;//Use for box (5)
  w[2][1]= -0.077401550372069; // -0.099874921777191; 
  w[4][0]=0.866025403784439;
  w[4][1]=-0.5;
  wt[6][0]=0.84;
  wt[6][1]=0.542586;
  wt[7][0]=0.8;
  wt[7][1]=-0.6;
  double QF[]={1.0,-0.8}; //0.01 1 is OK  //unstable stable

  for(int i=0; i<2; i++) {
    wt[i][0]=w[i][0];
    wt[i][1]=-w[i][1];
  }
  wt[2][0]=0.987;//w[1][0];
  wt[2][1]= 0.160720253857440;//-w[1][1];
  w[3][0]=w[1][0]; 
  w[3][1]=-w[1][1];
  wt[3][0]=0.975; //+
  wt[3][1]=-0.22220486; //-
  wt[4][0]=w[4][0];
  wt[4][1]=-w[4][1];
  w[5][0]=0.995;
  w[5][1]=0.099874921777191;
  wt[5][0]=0.994;
  wt[5][1]=-0.10938007;
  w[6]=w[4];

  centres[0][0]= 0.577619;
  centres[0][1]= 0.0;
  centres[1][0]=-0.14381616121589;
  centres[1][1]= 0.0;

  IVector seed=0.001*0.58120854283*w[1]+centres[1];//0.005*0.660285996
  centres[2]=midVector(H(midVector(H(midVector(H(midVector(H(seed))))))));
  std::cout<<centres[2]<<std::endl;
  for(int i=3; i<11; i++) {
    centres[i]=midVector(H(midVector(H(midVector(H(midVector(H(centres[i-1]))))))));
    std::cout<<centres[i]<<std::endl;
    }
  //exit(0);
  /*     IMatrix temp;
  temp=H[H(centres[1])]*H[centres[1]];
  std::cout<<temp<<std::endl; exit(0);*/
  //  centres[0]=centres[0]+0.0594*wt[0]+0.058*w[0];
  //centres[1]=centres[1]+0.065*wt[1]+0.0646*w[1]; 

  /* int N=1000;
  IVector test[N][15];
  for(int j=0; j<N; j++) { //0.31777, 100000
    //std::cout<<j<<std::endl;
    test[j][0]=0.001*(0.58120854283+(j+1)/(100000000000.0*N))*(w[1])+centres[1];
    //  std::cout<<test[j][0]<<std::endl;
  }

  double minnorm(100);
  int mini, minj;
  for(int i=1; i<10; i++) {
    for(int j=0; j<N; j++) {
      try {
	test[j][i]=midVector(H(midVector(H(midVector(H(midVector(H(test[j][i-1]))))))));
      }
      catch(...) {test[j][i]=test[j][i-1];}
      double testn=((test[j][i]-centres[0]).euclNorm()).rightBound();
      if(testn<minnorm) {
        minj=j;
        mini=i;
        minnorm=testn;
	std::cout<<i<<" "<<j<<" "<<minnorm<<std::endl;
      }
    }
  }
  for(int i=0; i<=mini; i++) 
    std::cout<<minj<<std::endl<<i<<" "<<test[minj][i]<<std::endl;
  
  exit(0);
  */
  /*  for(int i=0; i<11; i++) {
    std::cout<<"("<<w[i][0].leftBound()<<", "<<w[i][1].leftBound() <<") & ("
	     <<wt[i][0].leftBound()<<", "<<wt[i][1].leftBound()<<")"<<std::endl;
  }
  exit(0);*/
  hSet[0]=HSet(centres[0],0.001*wt[0], 0.001*w[0], QF); 
  hSet[1]=HSet(centres[1],0.00072*wt[1], 0.00072*w[1], QF); // stable unstable
  hSet[2]=HSet(centres[2],0.00054*wt[1], 0.00015*w[1], QF);
  hSet[3]=HSet(centres[3],0.00045*wt[1], 0.00015*w[1], QF);
  hSet[4]=HSet(centres[4],0.00047*wt[2], 0.0002  *w[2], QF);
  hSet[5]=HSet(centres[5],0.00055*wt[5], 0.00015*w[5], QF);
  hSet[6]=HSet(centres[6],0.0004*wt[3], 0.0001*w[3], QF);

  hSet[7]=HSet(centres[7],0.0004*wt[6], 0.0001*w[6], QF); 
  hSet[8]=HSet(centres[8],0.0003*wt[7], 0.0002*w[0], QF);

  hSet[9]=HSet(centres[9],0.0003*wt[0], 0.0002*w[0], QF);
  hSet[10]=HSet(centres[10],0.0005*wt[0], 0.0002*w[0], QF);

}


void computeEdge(Frame &f1, Frame &f2,
                 FuncPointer f, const GridSet &G,
                 HSet &destination, int color, HenonLike &H, bool notfixedPoint)
{
  unsigned i;
  for(i=0;i<G.center.size();i++)
    {
      IVector V = G.center[i] + G.C * G.r;
      
      f1.boxFill(V[0].leftBound(),V[1].leftBound(),V[0].rightBound(),V[1].rightBound(),color);
      
      f1.box(V[0].leftBound(),V[1].leftBound(),V[0].rightBound(),V[1].rightBound());
      if(notfixedPoint) {
	V=H(H(H(H(V)))); //H(V)
      }
      else {
	V=H(H(V));
      }
      
      f2.boxFill(V[0].leftBound(),V[1].leftBound(),V[0].rightBound(),V[1].rightBound(),color);
      
      f2.box(V[0].leftBound(),V[1].leftBound(),V[0].rightBound(),V[1].rightBound());
      
      if(!f(destination,V)){
	rootFrame << At(4,0) << "Inclusion not satisfied";
		std::cout<<"FAIL"<<std::endl;
		//	waitBt();
	//	exit(0);
      }
    }
} 

void setCoordinates(Frame &F, HSet &H) {
  double s=0.005;
  F.setWorldCoord(H.center[0]-s,H.center[1]-s,H.center[0]+s,H.center[1]+s);
}

void checkCoveringRelations(HSet *hSet, HenonLike &H) {
  GridSet G;
  int h=600;//600  int h[] = {20,20,100}; //20, 20, 100
  int v=500;//500 int v[] = {20,20,100};
  bool flip[] = {true, true, true, true, true, true}; 
  Frame F1(50,50,450,450);
  Frame F2(550,50,950,450);
  
  for(int i=0; i<12; i++) {
    rootFrame.Clear();
    F1.Bound(BROWN);
    F2.Bound(BROWN);
    int k,l;
    switch(i) {
    case 0:k=0; l=0; break;
    case 1:k=1; l=1; break;
    case 2:k=1; l=2; break;
    case 3:k=2; l=3; break;

    case 4:k=3; l=4; break;
     
    case 5:k=4; l=5; break; //

    case 6:k=5; l=6; break; //(

    case 7:k=6; l=7; break;
    case 8:k=7; l=8; break;
  
    case 9:k=8; l=9; break;
    case 10:k=9; l=10; break;
    case 11:k=10; l=0; break;
    }
 
    std::cout<<k<<" "<<l<<std::endl;
    setCoordinates(F1, hSet[k]);
    setCoordinates(F2, hSet[l]);
    F1 << dynamic_cast<GtSet&> (hSet[k]);
    F2 << dynamic_cast<GtSet&> (hSet[l]);
    if(i<2) {
      computeEdge(F1,F2,capd::covrel::Across,hSet[k].gridBottomEdge(G,h),hSet[l],GREEN,H, false);
      computeEdge(F1,F2,capd::covrel::Across,hSet[k].gridTopEdge(G,h),hSet[l],GREEN,H, false);
      if(i==0) {
	computeEdge(F1,F2,capd::covrel::RightSide,hSet[k].gridRightEdge(G,v),hSet[l],RED,H, false);
	computeEdge(F1,F2,capd::covrel::LeftSide,hSet[k].gridLeftEdge(G,v),hSet[l],BLUE,H, false);
      }
      else {
	computeEdge(F1,F2,capd::covrel::LeftSide,hSet[k].gridRightEdge(G,v),hSet[l],RED,H, false);
	computeEdge(F1,F2,capd::covrel::RightSide,hSet[k].gridLeftEdge(G,v),hSet[l],BLUE,H, false);
      }
    }
    else{
      computeEdge(F1,F2,capd::covrel::Across,hSet[k].gridBottomEdge(G,h),hSet[l],GREEN,H, true);
      computeEdge(F1,F2,capd::covrel::Across,hSet[k].gridTopEdge(G,h),hSet[l],GREEN,H, true);
      if(k>=5 && k<=7) {
	computeEdge(F1,F2,capd::covrel::LeftSide,hSet[k].gridRightEdge(G,v),hSet[l],RED,H, true);
	computeEdge(F1,F2,capd::covrel::RightSide,hSet[k].gridLeftEdge(G,v),hSet[l],BLUE,H, true);
      }
      else {
	computeEdge(F1,F2,capd::covrel::RightSide,hSet[k].gridRightEdge(G,v),hSet[l],RED,H, true);
	computeEdge(F1,F2,capd::covrel::LeftSide,hSet[k].gridLeftEdge(G,v),hSet[l],BLUE,H, true);
      }
    }
    
    // waitBt();
  }
}

IMatrix gridDerivative(const HenonLike &H, GridSet &G, int it) {
  GridSet::iterator b=G.begin(), e=G.end();
  IMatrix DF;
  bool first(true);
  IVector box=G.C*G.r;
  int k=0;
  while(b!=e) {
    k++;
    if(k==500*(k/500))
      std::cerr<<k<<" ";
    IVector U=(*b)+box;
    IMatrix DFtemp=H[U];
    
    if(it==2) {
      U=H(U);
      DFtemp=H[U]*DFtemp;
    }
    if(it==3) {
      U=H(U);
      DFtemp=H[U]*DFtemp;
      U=H(U);
      DFtemp=H[U]*DFtemp;
    }
    if(it==4) {
      U=H(U);
      DFtemp=H[U]*DFtemp;
      U=H(U);
      DFtemp=H[U]*DFtemp;
      U=H(U);
      DFtemp=H[U]*DFtemp;
    }



    if(first) {
      first=false;
      DF=DFtemp;
    } 
    else {
      DF=intervalHull(DF,DFtemp);
    }
    ++b;
  }

  return DF;
}


void checkConeCondition(const HenonLike &H, HSet &source, HSet &destination, int unStableGrid, int stableGrid, int it) {
  GridSet G;
  source.gridSet(G,unStableGrid,stableGrid);

  IMatrix DF=gridDerivative(H,G,it);
  //  std::cout<<DF<<std::endl;
  DF=capd::matrixAlgorithms::gaussInverseMatrix(destination.getCoordSystem())*DF*source.getCoordSystem();
 
  IMatrix V=Transpose(DF)*destination.get_QF()*DF-source.get_QF();
  if( !(V(1,1)>0 && (V(1,1)*V(2,2)-V(1,2)*V(2,1))>0 ) ) {
    std::cerr<<"Cone condition failed"<<std::endl
	     <<V(1,1)<<" "<<V(1,1)*V(2,2)-V(1,2)*V(2,1)<<std::endl;
    //exit(0);
  }
  else  {
      std::cerr<<"Cone condition succeded"<<std::endl
	       <<V(1,1)<<" "<<V(1,1)*V(2,2)-V(1,2)*V(2,1)<<std::endl;
  }
  
}

void checkConeConditionsGlobally(HSet *hSet, const HenonLike &H) {
  checkConeCondition(H,hSet[0],hSet[0],50,50,2);
  checkConeCondition(H,hSet[1],hSet[1],50,50,2);
  for(int i=2; i<12; i++) {
    int k,l;
    switch(i) {
    case 2:k=1; l=2; break;
    case 3:k=2; l=3; break;     
    case 4:k=3; l=4; break;
    case 5:k=4; l=5; break;
    case 6:k=5; l=6; break; 
    case 7:k=6; l=7; break;
    case 8:k=7; l=8; break;
    case 9:k=8; l=9; break;
    case 10:k=9; l=10; break;
    case 11:k=10; l=0; break;
    }
    if(i>=5 && i<=9)//6 and 9
      checkConeCondition(H,hSet[k],hSet[l],300,300,4);
    else
      checkConeCondition(H,hSet[k],hSet[l],100,100,4);
  }
}


int main(int argc, char* argv[])
{
  //  int i=atoi(argv[1]);
  try{
    openGW(1000,1000, WHITE, BLACK);
    rootFrame.setWorldCoord(-2,-2,3,3);
    HSet hSet[16];
    HenonLike H;
    initSets(H,hSet);
    
    checkCoveringRelations(hSet, H);
    waitBt();
    closeGW();
    checkConeConditionsGlobally(hSet, H);
  }
  catch(std::exception& e) {std::cout<<e.what()<<std::endl;}

 

}

