#ifndef __TYPEDEFS__
#define __TYPEDEFS__

#include <iostream>
#include <fstream>
#include <cstdlib>
#include "capd/interval/DoubleInterval.h"
#include "capd/vectalg/Vector.hpp"
#include "capd/vectalg/Matrix.hpp"
#include "capd/covrel/GraphicsTripleSet.h"
#include "capd/krak/krak.h"
#include "capd/krak/noframe.h"
#include "HSetWCones.h"

typedef capd::vectalg::Vector<double,2> DVector;
typedef capd::vectalg::Vector<interval,2> IVector;
typedef capd::vectalg::Vector<interval, 21> TCoefOne;

typedef capd::vectalg::Matrix<double,2,2> DMatrix;
typedef capd::vectalg::Matrix<interval,2,2> IMatrix;
typedef capd::vectalg::Matrix<interval,21,21> TCoefTwo;


typedef HSetWCones HSet;
typedef capd::covrel::GraphicsTripleSet GtSet;

typedef capd::covrel::GridSet<IMatrix> GridSet;

typedef bool (*FuncPointer)(const capd::covrel::TripleSet&, const IVector&); 


#endif
